<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-state-machine](./foundation-state-machine.md)

## foundation-state-machine package

## Classes

|  Class | Description |
|  --- | --- |
|  [APIError](./foundation-state-machine.apierror.md) | APIError. |
|  [DefaultFetchMachine](./foundation-state-machine.defaultfetchmachine.md) | Default FetchMachine. |
|  [GenesisServerError](./foundation-state-machine.genesisservererror.md) | GenesisServerError. |
|  [MappingError](./foundation-state-machine.mappingerror.md) | MappingError. |
|  [NetworkError](./foundation-state-machine.networkerror.md) | NetworkError. |

## Abstract Classes

|  Abstract Class | Description |
|  --- | --- |
|  [AbstractMachine](./foundation-state-machine.abstractmachine.md) | AbstractMachine base class. |

## Functions

|  Function | Description |
|  --- | --- |
|  [assertEvent(event, type)](./foundation-state-machine.assertevent.md) | assertEvent. |
|  [createErrorStateNode(key, metaContent, final)](./foundation-state-machine.createerrorstatenode.md) | Creates an error state node. |
|  [createFetchPolicy(maxAttempts, retryCodes, backoff, timeoutDuration, logEvents)](./foundation-state-machine.createfetchpolicy.md) | A fetch policy factory. |
|  [createResponseDataExtractorWithDeserializer(deserializer, extractor)](./foundation-state-machine.createresponsedataextractorwithdeserializer.md) | Creates an extractor that applies a deserializer to the extracted response data. |
|  [errorWorkflowInput(key)](./foundation-state-machine.errorworkflowinput.md) | Error workflow input. |
|  [isAbortError({ event })](./foundation-state-machine.isaborterror.md) | isAbortError. |
|  [isActorErrorEvent(actorId, event)](./foundation-state-machine.isactorerrorevent.md) | isActorErrorEvent. |
|  [isAPIError(error)](./foundation-state-machine.isapierror.md) |  |
|  [isDoneInvokeEvent(event)](./foundation-state-machine.isdoneinvokeevent.md) | isDoneInvokeEvent. |
|  [isErrorCustomEvent(event)](./foundation-state-machine.iserrorcustomevent.md) | isErrorCustomEvent. |
|  [isErrorEvent(event)](./foundation-state-machine.iserrorevent.md) | isErrorEvent. |
|  [isErrorType(type)](./foundation-state-machine.iserrortype.md) | isErrorType. |
|  [isEventWithParams(event)](./foundation-state-machine.iseventwithparams.md) | isEventWithParams. |
|  [isGenesisServerError(error)](./foundation-state-machine.isgenesisservererror.md) |  |
|  [isMappingError(error)](./foundation-state-machine.ismappingerror.md) |  |
|  [isNetworkError(error)](./foundation-state-machine.isnetworkerror.md) |  |
|  [isNotFoundError(error)](./foundation-state-machine.isnotfounderror.md) |  |
|  [isSyntaxError({ event })](./foundation-state-machine.issyntaxerror.md) | isSyntaxError. |
|  [isTypeError({ event })](./foundation-state-machine.istypeerror.md) | isTypeError. |
|  [isUnauthorizedError(error)](./foundation-state-machine.isunauthorizederror.md) |  |
|  [setErrorByKey(key)](./foundation-state-machine.seterrorbykey.md) | Set error by key action. |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [FetchConfig](./foundation-state-machine.fetchconfig.md) | FetchConfig interface. |
|  [FetchMachine](./foundation-state-machine.fetchmachine.md) | FetchMachine interface. |
|  [FetchMachineContext](./foundation-state-machine.fetchmachinecontext.md) | FetchMachineContext interface. |
|  [Machine](./foundation-state-machine.machine.md) | Machine interface. |
|  [MachineContext](./foundation-state-machine.machinecontext.md) | MachineContext interface. |

## Variables

|  Variable | Description |
|  --- | --- |
|  [defaultFetchConfig](./foundation-state-machine.defaultfetchconfig.md) | The default fetch config. |
|  [defaultFetchMachineContext](./foundation-state-machine.defaultfetchmachinecontext.md) | Default FetchMachineContext. |
|  [defaultFetchPolicy](./foundation-state-machine.defaultfetchpolicy.md) | The default fetch policy. |
|  [defaultResponseDataExtractor](./foundation-state-machine.defaultresponsedataextractor.md) | ResponseDataExtractor type. |
|  [defaultResponseOkChecker](./foundation-state-machine.defaultresponseokchecker.md) | ResponseOkChecker type. |
|  [defaultRetryStatsCodes](./foundation-state-machine.defaultretrystatscodes.md) | Default retry stats codes. |
|  [escalateError](./foundation-state-machine.escalateerror.md) | Escalate context error action. |
|  [logger](./foundation-state-machine.logger.md) |  |
|  [setError](./foundation-state-machine.seterror.md) | Set error action. |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [ErrorWorkflowInput](./foundation-state-machine.errorworkflowinput.md) | ErrorWorkflowInput type. |
|  [FetchMachineEvent](./foundation-state-machine.fetchmachineevent.md) | FetchMachineEvent type. |
|  [FetchMachineEventMap](./foundation-state-machine.fetchmachineeventmap.md) | FetchMachineEventMap type. |
|  [FetchMachineOutput](./foundation-state-machine.fetchmachineoutput.md) | FetchMachineOutput type. |
|  [ResponseDataExtractor](./foundation-state-machine.responsedataextractor.md) | ResponseDataExtractor type. |
|  [ResponseOkChecker](./foundation-state-machine.responseokchecker.md) | ResponseOkChecker type. |

